/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "ckDialog.h"
#include "ckButtonControl.h"
#include "ckComboBoxControl.h"
#include "ckPainter.h"
#include "ckControlGDI.h"

//
// ckOwnerPainter
//
// ugly
void ckOwnerPainter::paintButton(ckButtonControl &button)
{
    _LSDEBUG0;
    HDC memDC = CreateCompatibleDC(_drawitem->hDC);
    HBITMAP memBMP = CreateCompatibleBitmap(_drawitem->hDC, _drawitem->rcItem.right, _drawitem->rcItem.bottom);
    HGDIOBJ oldBMP = NULL;
    if(memDC && memBMP)
    {
        _LSDEBUG0;
        oldBMP = SelectObject(memDC, memBMP);

        if(button.getBG())
        {
            _LSDEBUG0;
            FillRect(memDC, &(_drawitem->rcItem), (HBRUSH)(HGDIOBJ)(*(button.getBG())));    
            SetBkMode(memDC, TRANSPARENT);
            assert(button.getBGColor());
            SetBkColor(memDC, *(button.getBGColor()));
        }
        _LSDEBUG0;
        if(button.getFontColor())
        {
            _LSDEBUG0;
            SetTextColor(memDC, *(button.getFontColor()));
        }
        _LSDEBUG0;
        if(button.getLight() && button.getDark())
        {
            _LSDEBUG0;
            //will use RLC later
            HPEN lightpen;// = (HPEN)(HGDIOBJ)(*(button.getLight()));
            HPEN darkpen;// = (HPEN)(HGDIOBJ)(*(button.getDark()));
            LRESULT state = SendMessage(button.getHWND(), BST_PUSHED, 0, 0);
            if(state == BST_PUSHED || _drawitem->itemState == ODS_FOCUS)
            {
                lightpen = (HPEN)(HGDIOBJ)(*(button.getDark()));
                darkpen = (HPEN)(HGDIOBJ)(*(button.getLight()));
            }
            else
            {
                lightpen = (HPEN)(HGDIOBJ)(*(button.getLight()));
                darkpen = (HPEN)(HGDIOBJ)(*(button.getDark()));
            }


            RECT r = _drawitem->rcItem;
            --r.right;
            --r.bottom;

            HGDIOBJ oldfont = NULL;
            if(button.getFont())
            {
                oldfont = SelectObject(memDC, (HGDIOBJ)(*(button.getFont())));
            }

            string str = ckControlImpMap<ckDialogImp>::instance()->getImp()->_getText(button).c_str();
            RECT fontr = r;
            if((state == BST_PUSHED || _drawitem->itemState == ODS_FOCUS))
            {
                ++fontr.left;
                ++fontr.right;
                --fontr.top;
                --fontr.bottom;
            }
            DrawText(memDC, 
                    str.c_str(), 
                    str.length(), 
                    &fontr, 
                    DT_CENTER | DT_VCENTER|DT_SINGLELINE);

            if(oldfont)
                SelectObject(memDC, oldfont);

		    MoveToEx(memDC, r.left, r.bottom, NULL);
		    
		    //draw outer shadow
		    HGDIOBJ oldpen = SelectObject(memDC, darkpen);
		    LineTo(memDC, r.left, r.top);
		    LineTo(memDC, r.right, r.top);
		    
		    //draw outer highlight
		    SelectObject(memDC, lightpen);						
		    LineTo(memDC, r.right, r.bottom);
            LineTo(memDC, r.left, r.bottom);
		    
		    //skip outer bottom highlight and move to top right of inner to continue drawing
		    MoveToEx(memDC, r.right-1, r.top+1, NULL);
		    
		    //draw inner shadow
		    SelectObject(memDC, darkpen);
		    LineTo(memDC, r.right-1, r.bottom-1);
		    LineTo(memDC, r.left+1, r.bottom-1);
		    
		    //draw inner highlight
		    SelectObject(memDC, lightpen);
		    LineTo(memDC, r.left+1, r.top+1);
		    LineTo(memDC, r.right-1, r.top+1);
		    
            SelectObject(memDC, oldpen);
            _LSDEBUG0;
            BitBlt( _drawitem->hDC, 
                    _drawitem->rcItem.left, 
                    _drawitem->rcItem.top,
                    _drawitem->rcItem.right - _drawitem->rcItem.left, 
                    _drawitem->rcItem.bottom - _drawitem->rcItem.top, 
                    memDC, 
                    _drawitem->rcItem.left,
                    _drawitem->rcItem.top,
                    SRCCOPY);
        
        }
    }

    if(memBMP)
    {
        if(memDC)
            SelectObject(memDC, oldBMP);
        DeleteObject(memBMP);
    }

    if(memDC)
        DeleteDC(memDC);
    
}

//ugly ass!
void ckOwnerPainter::paintComboBox(ckComboBoxControl &combobox)
{
    _LSDEBUG0;
    if(_drawitem->itemID == -1) return;

    HDC memDC = CreateCompatibleDC(_drawitem->hDC);
    HBITMAP memBMP = CreateCompatibleBitmap(_drawitem->hDC, _drawitem->rcItem.right, _drawitem->rcItem.bottom);
    HGDIOBJ oldBMP = NULL;
    if(memDC && memBMP)
    {
        _LSDEBUG0;
        oldBMP = SelectObject(memDC, memBMP);

        if(combobox.getBG())
        {
            _LSDEBUG0;
            Brush *bgbrush = _drawitem->itemState & ODS_SELECTED ? 
                                combobox.getSelBrush() : combobox.getBG();    
            if(bgbrush)
                FillRect(memDC, &(_drawitem->rcItem), (HBRUSH)(HGDIOBJ)(*bgbrush));

            SetBkMode(memDC, TRANSPARENT);
            assert(combobox.getBGColor());
            SetBkColor(memDC, *(combobox.getBGColor()));
        }
        _LSDEBUG0;
        COLORREF *fontcolor = _drawitem->itemState ? combobox.getFontColor() : combobox.getSelTextColor();
        if(fontcolor)
        {
            _LSDEBUG0;
            SetTextColor(memDC, *fontcolor);
        }
        _LSDEBUG0;

        _LSDEBUG0;
        //will use RLC later
        
        HGDIOBJ oldfont = NULL;
        if(combobox.getFont())
        {
            oldfont = SelectObject(memDC, (HGDIOBJ)(*(combobox.getFont())));
        }

        string str = ckControlImpMap<ckComboBoxImp>::instance()->getImp()->_getText(combobox, _drawitem->itemID);
        DrawText(memDC, 
                str.c_str(), 
                str.length(), 
                &(_drawitem->rcItem), 
                DT_VCENTER|DT_SINGLELINE);

        if(oldfont)
            SelectObject(memDC, oldfont);
	
        _LSDEBUG0;
        BitBlt( _drawitem->hDC, 
                _drawitem->rcItem.left, 
                _drawitem->rcItem.top,
                _drawitem->rcItem.right - _drawitem->rcItem.left, 
                _drawitem->rcItem.bottom - _drawitem->rcItem.top, 
                memDC, 
                _drawitem->rcItem.left,
                _drawitem->rcItem.top,
                SRCCOPY);
    }

    if(memBMP)
    {
        if(memDC)
            SelectObject(memDC, oldBMP);
        DeleteObject(memBMP);
    }

    if(memDC)
        DeleteDC(memDC);

}